# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section   free

Name:           hivemind
Version:        1.1.1
Release:        2jpp
Epoch:          0
Summary:        HiveMind Microkernel

Group:          Development/Libraries/Java
License:        Apache Software License
URL:            http://hivemind.apache.org/
Source0:        hivemind-1.1.1.tar.gz
Patch0:         hivemind-hivebuild-properties.patch
Patch1:         hivemind-framework-build.patch
Patch2:         hivemind-hivebuild-module.patch
Patch3:         hivemind-hivebuild-module-properties.patch
Patch4:         hivemind-library-build.patch
Patch5:         hivemind-jmx-build.patch
Patch6:         hivemind-jmx-TestMBeanRegistry.patch
Patch7:         hivemind-examples-build.patch
Patch8:         hivemind-examples-TestTaskExecutor.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}

%if ! %{gcj_support}
BuildArch:      noarch
%endif

%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  easymock
BuildRequires:  easymock-classextension
BuildRequires:  junit

BuildRequires:  aopalliance
BuildRequires:  cglib
BuildRequires:  geronimo-ejb-2.1-api
BuildRequires:  groovy-jsr
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-oro
BuildRequires:  javassist
BuildRequires:  log4j
BuildRequires:  mx4j
BuildRequires:  servletapi4
BuildRequires:  spring-all
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis

Requires:  easymock
Requires:  easymock-classextension
Requires:  jakarta-commons-logging
Requires:  jakarta-oro
Requires:  javassist
Requires:  junit
Requires:  log4j
Requires:  servletapi4
Requires:  xml-commons-apis

%description
HiveMind is an services and configuration microkernel. Its 
features are also referred to as Inversion of Control (IoC) 
Container or Lightweight Container. The adoption of HiveMind 
in an application ensures the use of certain design principles 
which improve encapsulation, modularization, testability and 
reusability. 

%package        lib
Summary:        Library extensions for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       aopalliance
Requires:       ejb
Requires:       groovy-jsr
Requires:       spring-all
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif


%description    lib
%{summary}.

%package        jmx
Summary:        JMX extensions for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       mx4j
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description    jmx
%{summary}.

%package        demo
Summary:        Examples for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       ejb
%if %{gcj_support}
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description    demo
%{summary}.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description    javadoc
%{summary}.


%prep
%setup -q -n %{name}-%{version}
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mv framework/src/test-data/TestConstructRegistry/empty.jar.no \
             framework/src/test-data/TestConstructRegistry/empty.jar
mv framework/src/test-data/TestConstructRegistry/module.jar.no \
             framework/src/test-data/TestConstructRegistry/module.jar
mv framework/src/test-data/TestRegistryBuilder.jar.no \
             framework/src/test-data/TestRegistryBuilder.jar

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
mkdir -p repository/JPP/jars
pushd repository/JPP/jars
ln -sf $(build-classpath ant) ant-.jar
ln -sf $(build-classpath commons-logging) commons-logging-.jar
ln -sf $(build-classpath javassist) javassist-.jar
ln -sf $(build-classpath servletapi4) servletapi-.jar
ln -sf $(build-classpath oro) oro-.jar
ln -sf $(build-classpath log4j) log4j-.jar
ln -sf $(build-classpath easymock) easymock-.jar
ln -sf $(build-classpath easymock-classextension) easymockclassextension-.jar
ln -sf $(build-classpath cglib-nodep) cglib-full-.jar
ln -sf $(build-classpath junit) junit-.jar
ln -sf $(build-classpath xerces-j2) xercesImpl-.jar
ln -sf $(build-classpath geronimo-ejb-2.1-api) geronimo-ejb-2.1-api-.jar
ln -sf $(build-classpath spring) spring-full-.jar
ln -sf $(build-classpath groovy-jsr-all) groovy-jsr-all-.jar
ln -sf $(build-classpath aopalliance) aopalliance-.jar
ln -sf $(build-classpath mx4j/mx4j) mx4j-.jar
ln -sf $(build-classpath mx4j/mx4j-tools) mx4j-tools-.jar
ln -sf $(build-classpath mx4j/mx4j-remote) mx4j-remote-.jar
popd

%build
mkdir tmp
mkdir -p ext-package/lib
touch ext-package/download-warning-marker
ln -sf $(build-classpath xml-commons-apis) ext-package/lib/xml-apis-.jar
export OPT_JAR_LIST="ant/ant-nodeps ant/ant-junit junit ant/ant-trax"
export RD=$(pwd)
ant -Dscratch.dir=${RD}/tmp -Droot.dir=${RD} install run-reports
pushd framework
ant -Dscratch.dir=${RD}/tmp -Droot.dir=${RD} javadoc
popd
pushd library
ant -Dscratch.dir=${RD}/tmp -Droot.dir=${RD} javadoc
popd
pushd jmx
ant -Dscratch.dir=${RD}/tmp -Droot.dir=${RD} javadoc
popd

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_javadir}

install -pm 644 target/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}
install -pm 644 target/%{name}-jmx-%{version}.jar $RPM_BUILD_ROOT%{_javadir}
install -pm 644 target/%{name}-lib-%{version}.jar $RPM_BUILD_ROOT%{_javadir}
install -pm 644 examples/target/%{name}-examples-%{version}.jar \
                                                  $RPM_BUILD_ROOT%{_javadir}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/framework
cp -pr tmp/jakarta-hivemind/target/docs/hivemind/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/framework
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jmx
cp -pr tmp/jakarta-hivemind/target/docs/hivemind-jmx/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/jmx
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/library
cp -pr tmp/jakarta-hivemind/target/docs/hivemind-lib/apidocs/* \
                $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/library
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post jmx
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun jmx
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post lib
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun lib
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post demo
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun demo
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files jmx
%defattr(-,root,root,-)
%{_javadir}/%{name}-jmx-%{version}.jar
%{_javadir}/%{name}-jmx.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-jmx-%{version}.jar.*
%endif

%files lib
%defattr(-,root,root,-)
%{_javadir}/%{name}-lib-%{version}.jar
%{_javadir}/%{name}-lib.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-lib-%{version}.jar.*
%endif

%files demo
%defattr(-,root,root,-)
%{_javadir}/%{name}-examples-%{version}.jar
%{_javadir}/%{name}-examples.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-examples-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Mon May 14 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-2jpp
- Make Vendor, Distribution based on macro

* Tue Apr 17 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.1.1-1jpp
- First JPackage release

